// VARIABLES  ===============================================================================

const URL_CHECK_ID = 'upload.php';
const URL_DETOURAGE = "removeBackground2.php";
const URL_WEB_API = 'web_server.php';
const URL_CHOOSE_MAIL = 'io.php';
const URL_END = 'byebye.html';

const ID = "img-ID";
const canva = "canvas";
console.log($("#"+ID).attr('src'));

const idConsole = "div";var Console;

const idFileUpload = "fileUpload"; var inputFileUpload;
const idCustomFileUpload = "custom-fileUpload"; var btnCustomFileUpload;
const idBtnSubmit = 'btnSubmit';var btnSubmit;

const idStatut = "span-status";

var errorUpload = true;
var errorRemoveBackGround = true;

var unSeulVisage = false;
var format_correct = false;


// SCRIPT ====================================================================================

$(document).ready(function(){
  inputFileUpload = $("#"+idFileUpload);
  // console.log(inputFileUpload.val());
  console.log(getParameter(window.location.href));
  btnCustomFileUpload = $("#"+idCustomFileUpload);
  btnSubmit = $("#"+idBtnSubmit);
  Console = $("#"+idConsole);

    $("#form").on("submit",function (event) {
        event.preventDefault();
        var formData = new FormData(this);
        console.log(inputFileUpload.attr('filename'));
        $.ajax({
          //url de la requête
          url: URL_CHECK_ID,
          method: 'POST',
          enctype: 'multipart/form-data',
          data: formData,

          cache: false,
          dataType: "json",
          contentType: false,
          processData: false
        })
        .done(function(data){
          console.log(data);
          src = data['src'];
          console.log('src');
          errorUpload = data['error'];
          Console.empty();
          Console.append(data['message']);

          //Affichage de la photo
          // findFaces();
        })
        .fail(function(error){
          Console.empty();
          alert("La requête s'est terminée en échec. Infos : " + JSON.stringify(error));
        })


        $.ajax({
          //url de la requête
          url: URL_DETOURAGE,
          
          method: 'POST',
          enctype: 'multipart/form-data',
          data: formData,
          cache: false,

          dataType: "json",
          contentType: false,
          processData: false
      })
      .done(function(data){
        console.log(data);

        //Affichage de la photo
        $("#img-ID2").attr('src',data['src']);
      })
    });
    

    //Etape du choix de l'addresse mail.
    $("#photovalidé").on('click',function(){
      studentId = getParameter(window.location.href);
      $.ajax({
        url: URL_WEB_API,
        method: 'POST',
        data: 'studentId='+studentId,
        dataType: "json"
      })
      .done(function(response){
        // let data = JSON.stringify(response);
        // $("div#res").append(data);
        let data = response;
        console.log(data);
        let studentIdRes = data['studentId'];
        let prenom = data['prenom'];
        let nom = data['nom'];
        let mailCalcule = data["mailCalcule"];
        let mailsPossibles = data["mailsPossibles"];

        if(mailsPossibles.length!=0){
        $("body").append(
          `<h3>Bonjour <strong>${prenom}</strong>, veuillez choisir votre prochaine adresse électronique</h3>
          <div class = "form-container div-form" id="email-container" >
            <div class="title-container"> <h2>Choix de l'adresse électronique</h2></div>
            <form id ="choix-email" name="mail" class="div-form form-emails" action="" method="" onsubmit="event.preventDefault();sendMail()"> 
            </form>
          </div>`
        );
        let required = 0;
        mailsPossibles.forEach(element => {
          $('#choix-email').append(
            `<input type="radio" id="${element}" name="mail" value="${element}" required>
            <label for="${element}"> ${element}</label><br>`
          );
        });
        $("#choix-email input").attr('checked')
        $("#choix-email").append(
          `<input type="submit" id="valide-mail" value="Ok c'est bon !">`
        );
        }
    })
  });

  
});

// FONCTIONS  ================================================================================
function sendMail(){
  console.log($("input[name=\"mail\"]:checked").val());
  var mail = $("input[name=\"mail\"]:checked").val();

  $.ajax({
    url: URL_CHOOSE_MAIL,
    method: 'POST',
    data: 'mail='+mail,
    dataType: "json"
  });
  setTimeout(function () {
    window.open(URL_END, '_self');
}, 000);;
  // window.close();
}


async function findFaces(idImage) {
  btnCustomFileUpload.prop('disabled',true);
  btnSubmit.prop('disabled',true);
  console.log('_findFaces()');
  const model = await blazeface.load();  
  // const img = ID;
  console.log(idImage);
  const img = document.getElementById(idImage);
  const predictions = await model.estimateFaces(img, false);
  console.log('_findFaces()');
  if (predictions.length > 0) {
      console.log("faces found");
      console.log(predictions.length);
      $("#"+idStatut).empty();
      $("#"+idStatut).append(predictions.length+" face(s) found!");
      if(predictions.length==1){
        $("#li-oneface").css('color','green');
      }
      else{$("#li-oneface").css('color','red');}

      // const canvas =  document.getElementById(canva);
      // canvas.width = img.width;
      // canvas.height = img.height;
      // const ctx = canvas.getContext("2d");
      // ctx.fillStyle = "rgba(250,225,6,0.5)";
      // for (let i = 0; i < predictions.length; i++) 
      // {
      //   const start = predictions[i].topLeft;
      //   const end = predictions[i].bottomRight;
      //   const size = [end[0] - start[0], end[1] - start[1]];
      //   ctx.fillRect(start[0], start[1], size[0], size[1]);
      //   var landmark;
      //   for (let j = 0; j < predictions[i].landmarks.length; j++)
      //   {
      //     landmark = predictions[i].landmarks[j];
      //     ctx.beginPath();
      //     ctx.arc(landmark[0],landmark[1], 1, 0, 2*Math.PI,false);
      //     ctx.fill();
      //     ctx.lineWidth = 1;
      //     ctx.strokeStyle = '#ff0000';
      //     ctx.stroke();
      //   }
      // }
  } 
  else {
    $("#"+idStatut).empty();
    $("#"+idStatut).append("No Face(s) Found");
    $("#li-oneface").css('color','red');
  }
  // btnSubmit.prop('disabled',false);
  btnCustomFileUpload.prop('disabled',false);
}

function getParameter(url){
  L = url.length;
  l=0;
  parameter="";
  for (var k = 0; k<L; k++){
    l=k
    if(url[k]=="?"){break;}
  }
  while (url[l]!="=")
  {
    l=l+1;
  }
  l=l+1;
  while(l<L&& url[l]!="&")
  {
    parameter+=url[l];
    l=l+1;
  }
  // console.log(parameter);
  return parameter;
}

function getFile(filePath) {
  return filePath.substr(filePath.lastIndexOf('\\') + 1) ;
}


